package com.example.dbunit;

import java.util.List;

import com.seitenbau.testing.addons.dbunit.generator.PartGeneratorDBUnit;
import com.seitenbau.testing.addons.dbunit.listener.DbUnitTableConfig;
import com.seitenbau.testing.service.RepositoryService;
import com.seitenbau.testing.service.TestGenerator;
import com.seitenbau.testing.shared.config.MethodConfiguration;
import com.seitenbau.testing.shared.config.TestConfiguration;
import com.seitenbau.testing.shared.model.RecordedMethodConfiguration;
import com.seitenbau.testing.testgenerator.datadriven.GeneratorDataDriven;
import com.seitenbau.testing.testgenerator.partgenerator.impl.PartGeneratorReturnValueAssertEquals;

public class DBUnitclass_simpleDatabaseMethod_generateTests {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		TestConfiguration configuration=new TestConfiguration();

		MethodConfiguration methodConfiguration=MethodConfiguration.buildFor(DBUnitClass.class, "simpleDatabaseMethod");

		List<RecordedMethodConfiguration> methodList=RepositoryService.getTestData(methodConfiguration, null );

		configuration.setTestData(methodList);

		GeneratorDataDriven generator=new GeneratorDataDriven();;

		generator.addPartGenerator( new PartGeneratorReturnValueAssertEquals() );

		PartGeneratorDBUnit db = new PartGeneratorDBUnit();

		DbUnitTableConfig tab=new DbUnitTableConfig();
    db.addTable( tab );
    tab.setTableName("customer");
    tab.addExcludeColumn("ids");
		generator.addPartGenerator( db );

		TestGenerator.createTestArtifacts(generator, configuration, "src/test/java", "src/test/resources");

	}

}
