package com.example.documentation;

import java.util.List;

import com.seitenbau.testing.service.RepositoryService;
import com.seitenbau.testing.service.TestGenerator;
import com.seitenbau.testing.shared.config.MethodConfiguration;
import com.seitenbau.testing.shared.config.RepositoryConfig;
import com.seitenbau.testing.shared.config.TestConfiguration;
import com.seitenbau.testing.shared.model.RecordedMethodConfiguration;
import com.seitenbau.testing.testgenerator.datadriven.GeneratorDataDriven;
import com.seitenbau.testing.testgenerator.partgenerator.impl.PartGeneratorReturnValueAssertEquals;
import com.seitenbau.testing.testgenerator.partgenerator.impl.PartGeneratorTargetCreateNewInstance;


public class generateTest
{
  public static void main(String[] args)
  {
    // Specify the repository
    RepositoryConfig repository = new RepositoryConfig();

    repository.setDriverClass("com.mysql.jdbc.Driver");
    repository.setDatabaseURL("jdbc:mysql://localhost/sbtestrecorder");
    repository.setUsername("root");
    repository.setPassword("");

    // Prepare filtering for target method
    MethodConfiguration methodConfiguration = new MethodConfiguration();

    methodConfiguration.setReturnType("int");
    methodConfiguration.setPackageName("org.example");
    methodConfiguration.setClassName("SomeClass");
    methodConfiguration.setMethodName("getMax");
    methodConfiguration.setParameters("int, int");

    // Retrieve ALL tests Data from repository for the target method
    List<RecordedMethodConfiguration> daten = RepositoryService.getTestData(
        methodConfiguration, repository);

    TestConfiguration configuration = new TestConfiguration();

    configuration.setTestData(daten);

    // Setup Part Generators
    GeneratorDataDriven generator = new GeneratorDataDriven();

    generator.addPartGenerator(new PartGeneratorTargetCreateNewInstance());
    generator.addPartGenerator(new PartGeneratorReturnValueAssertEquals());

    TestGenerator.createTestArtifacts(generator, configuration,
        "src/test/java", "src/test/resources");
  }

}
