package com.example.parametertypes;

import java.util.List;

import com.seitenbau.testing.service.RepositoryService;
import com.seitenbau.testing.service.TestGenerator;
import com.seitenbau.testing.shared.config.MethodConfiguration;
import com.seitenbau.testing.shared.config.TestConfiguration;
import com.seitenbau.testing.shared.model.RecordedMethodConfiguration;
import com.seitenbau.testing.testgenerator.datadriven.GeneratorDataDriven;
import com.seitenbau.testing.testgenerator.partgenerator.impl.PartGeneratorReturnValueAssertEquals;
import com.seitenbau.testing.testgenerator.partgenerator.impl.PartGeneratorTargetCreateNewInstance;

public class ParameterClass_anMethod_testGenerator
{
  public static void main(String[] args)
  {
    generate(new MethodConfiguration(ParameterClass.class,"withStringParmeter"), "withStringParmeter");
    generate(new MethodConfiguration(ParameterClass.class,"withIntegerParmeter"), "withIntegerParmeter");
    generate(new MethodConfiguration(ParameterClass.class,"withStringArrayParmeter"), "withStringArrayParmeter");
    generate(new MethodConfiguration(ParameterClass.class,"withIntArrayParmeter"), "withIntArrayParmeter");
  }

  private static void generate(MethodConfiguration configuration,String prefix)
  {
    List<RecordedMethodConfiguration> data = RepositoryService.getTestData(configuration, null);

    TestConfiguration testConfig=new TestConfiguration();
    testConfig.setBaseName(prefix);

    testConfig.setTestData( data );

    GeneratorDataDriven generator=new GeneratorDataDriven();

    generator.addPartGenerator( new PartGeneratorReturnValueAssertEquals() );
    generator.addPartGenerator( new PartGeneratorTargetCreateNewInstance() );

    TestGenerator.createTestArtifacts(generator, testConfig, "src/test/java","src/test/resources");
  }
}
