package com.example.refactoring;

import java.util.List;

import com.seitenbau.testing.service.RepositoryService;
import com.seitenbau.testing.service.TestGenerator;
import com.seitenbau.testing.shared.config.MethodConfiguration;
import com.seitenbau.testing.shared.config.TestConfiguration;
import com.seitenbau.testing.shared.model.RecordedMethodConfiguration;
import com.seitenbau.testing.testgenerator.datadriven.GeneratorDataDriven;
import com.seitenbau.testing.testgenerator.partgenerator.impl.PartGeneratorReturnValueAssertEquals;
import com.seitenbau.testing.testgenerator.partgenerator.impl.PartGeneratorTargetCreateNewInstance;
import com.seitenbau.testing.testgenerator.partgenerator.impl.PartGeneratorTargetFromPreState;

public class Refactoring_testGenerator {

	public static void main(String[] args) {
		m1();
		m2();
	}

	private static void m2() {
		MethodConfiguration configuration = new MethodConfiguration( 
				Refactoring.class, "methodTests");

		List<RecordedMethodConfiguration> data = RepositoryService.getTestData(
				configuration, null);

		TestConfiguration testConfig = new TestConfiguration();
		testConfig.setBaseName("method");

		testConfig.setTestData(data);

		GeneratorDataDriven generator = new GeneratorDataDriven();

		generator.addPartGenerator(new PartGeneratorReturnValueAssertEquals());
		generator.addPartGenerator(new PartGeneratorTargetCreateNewInstance());

		TestGenerator.createTestArtifacts(generator, testConfig,
				"src/test/java", "src/test/resources");
	}

	private static void m1() {
		MethodConfiguration configuration = new MethodConfiguration( 
				Refactoring.class, "addPrestate");
		

		List<RecordedMethodConfiguration> data = RepositoryService.getTestData(
				configuration, null);

		TestConfiguration testConfig = new TestConfiguration();
		testConfig.setBaseName("prestate");

		testConfig.setTestData(data);

		GeneratorDataDriven generator = new GeneratorDataDriven();

		generator.addPartGenerator(new PartGeneratorReturnValueAssertEquals());
//		generator.addPartGenerator(new PartGeneratorTargetCreateNewInstance());
		generator.addPartGenerator(new PartGeneratorTargetFromPreState());

		TestGenerator.createTestArtifacts(generator, testConfig,
				"src/test/java", "src/test/resources");		
	}

}
