package com.example.stream;

import java.util.List;

import com.seitenbau.testing.service.RepositoryService;
import com.seitenbau.testing.service.TestGenerator;
import com.seitenbau.testing.shared.config.MethodConfiguration;
import com.seitenbau.testing.shared.config.TestConfiguration;
import com.seitenbau.testing.shared.model.RecordedMethodConfiguration;
import com.seitenbau.testing.testgenerator.datadriven.GeneratorDataDriven;
import com.seitenbau.testing.testgenerator.partgenerator.impl.PartGeneratorReturnValueAssertEquals;
import com.seitenbau.testing.testgenerator.partgenerator.impl.PartGeneratorTargetCreateNewInstance;

public class StreamClass_testGenerator {


	public static void main(String[] args) {
		MethodConfiguration configuration = new MethodConfiguration( StreamClass.class, "print");

		List<RecordedMethodConfiguration> data = RepositoryService.getTestData(
				configuration, null);

		TestConfiguration testConfig = new TestConfiguration();

		testConfig.setTestData(data);

		GeneratorDataDriven generator = new GeneratorDataDriven();

		generator.addPartGenerator(new PartGeneratorReturnValueAssertEquals());
		generator.addPartGenerator(new PartGeneratorTargetCreateNewInstance());

		TestGenerator.createTestArtifacts(generator, testConfig,
				"src/test/java", "src/test/resources");
	}

}
