package com.example.xstream;

import com.seitenbau.testing.service.Instrumentation;
import com.seitenbau.testing.shared.model.ObjectSnapshot;
import com.seitenbau.testing.shared.model.ObjectSnapshotConverter;
import com.thoughtworks.xstream.XStream;

public class XStreamSamples {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// testNULL();
		ReferenceProblem();
		// feld();

		// Asmembersttest();

		// primstream();

		// OSC();

	}

	@SuppressWarnings("unused")
	private static void OSC() {
		Object o = null;
		o.toString();

		ObjectSnapshotConverter osc = new ObjectSnapshotConverter(null);

		ObjectSnapshot os = osc.makeSnapshot(new sClass(), true);
		System.out.println(os.getXMLString());
		System.out.println(os.getStaticXMLString());
		System.out.println(os.getMetaInfo());
	}

	private static class sClass {
		static int statischerWert = 12;
	}

	@SuppressWarnings("unused")
	private static void Asmembersttest() {
		XStream xs = new XStream();

		AsMembers am = new AsMembers();

		System.out.println(xs.toXML(am));
		String text = "Hello World";
		System.out.println(xs.toXML(text));
	}

	@SuppressWarnings("unused")
	private static void primstream() {
		XStream xs = new XStream();
		int i = 42;
		System.out.println(xs.toXML(i));
		String text = "Hello World";
		System.out.println(xs.toXML(text));
	}

	public static class AsMembers {
		int zahl = 23;
		String text = "Hello World";
		Instrumentation i2 = new Instrumentation();
	}

	@SuppressWarnings("unused")
	private static void feld() {
		XStream xs = new XStream();

		String[] feld = { "Suppen", "Teller" };
		System.out.println(xs.toXML(feld));
	}

	private static void ReferenceProblem() {
		XStream xs = new XStream();

		Object obj = new Object();

		System.out.println(obj.equals(obj));

		String xml = xs.toXML(obj);

		Object neu = xs.fromXML(xml);
		Object param = xs.fromXML(xml);

		System.out.println(neu.equals(param));
	}

	@SuppressWarnings( "unused" )
	private static void testNULL() {
		XStream xs = new XStream();

		System.out.println(xs.toXML(null));
	}

}
