package com.seitenbau.testing.recorderexampleusage;

import java.util.List;
import java.util.Vector;

import com.seitenbau.testing.addons.dbunit.listener.DbUnitListenerConfiguration;
import com.seitenbau.testing.shared.config.ExcludeFieldConfiguration;
import com.seitenbau.testing.shared.config.ListenerConfiguration;
import com.seitenbau.testing.shared.config.MethodConfiguration;
import com.seitenbau.testing.shared.config.RecorderConfiguration;
import com.seitenbau.testing.shared.config.RepositoryConfig;
import com.seitenbau.testing.shared.config.TracerConfiguration;
import com.seitenbau.testing.shared.tracer.listener.ConsoleListener;


public class ConfigurationBuilder {

	public static RecorderConfiguration build() {
		RecorderConfiguration rcfg=new RecorderConfiguration();

		rcfg.setRepository(buildDatabase());

		rcfg.addMethodConfiguration(buildMethod());

		return rcfg;
	}

  public static RepositoryConfig buildDatabase() {
    RepositoryConfig dcfg=new RepositoryConfig();

    dcfg.setDatabaseURL("jdbc:mysql://localhost/atr");
    dcfg.setUsername("root");
    dcfg.setPassword("");
    return dcfg;
  }

	public static MethodConfiguration buildMathMethod() {
		MethodConfiguration mcfg=new MethodConfiguration();

		mcfg.setPackageName("com.example.testprogram");
		mcfg.setClassName  ("MathOperations");
		mcfg.setMethodName ("adding");
		mcfg.setParameters ("String,String");
		mcfg.setReturnType ("String");

		mcfg.setTracer( buildTracer() );
		mcfg.setExcludeFields( buildExcluededFields() );
		return mcfg;
	}

	public static MethodConfiguration buildMethod() {
		MethodConfiguration mcfg=new MethodConfiguration();

		mcfg.setPackageName("com.example.tr");
		mcfg.setClassName("ClassUnderTest");
		mcfg.setMethodName("methodToTest");
		mcfg.setParameters("String");
		mcfg.setReturnType("int");

		mcfg.setTracer( buildTracer() );
		mcfg.setExcludeFields( buildExcluededFields() );
		return mcfg;
	}

	private static List<ExcludeFieldConfiguration> buildExcluededFields() {
		List<ExcludeFieldConfiguration> cfg=new Vector<ExcludeFieldConfiguration>();
		ExcludeFieldConfiguration ef = new ExcludeFieldConfiguration();
		ef.setClassName("java.lang.Throwable");
		ef.setFieldName("stackTrace");
		cfg.add( ef );
		return cfg;
	}

	public static TracerConfiguration buildTracer() {
		TracerConfiguration tcfg = new TracerConfiguration();
		tcfg.getProperties().setProperty("recordMethodTrace", "true");

		tcfg.addListener( new ListenerConfiguration( ConsoleListener.class) );
		tcfg.addListener( new DbUnitListenerConfiguration() );
//		tcfg.addListener( buildConsoleListener() );
		return tcfg;
	}

//	public static ListenerConfiguration buildConsoleListener() {
//		DbUnitListenerConfiguration lcfg = new DbUnitListenerConfiguration();
//		lcfg.setDatabaseDriver("com.mysql.jdbc.Driver");
//		lcfg.setDatabaseURL("jdbc:mysql://localhost/atr");
//		lcfg.setDatabaseUsername("root");
//		lcfg.setDatabasePassword("");
//
//		DbUnitTableConfig tableCfg=new DbUnitTableConfig();
//		tableCfg.setTableName("ObjectSnapshot");
//		lcfg.add( tableCfg );
//		return lcfg;
//	}


}
