package com.seitenbau.testing.recorderexampleusage;

import java.util.LinkedList;
import java.util.List;

import com.seitenbau.testing.service.RepositoryService;
import com.seitenbau.testing.service.TestGenerator;
import com.seitenbau.testing.shared.config.RecorderConfiguration;
import com.seitenbau.testing.shared.config.TestConfiguration;
import com.seitenbau.testing.shared.model.RecordedMethodConfiguration;
import com.seitenbau.testing.shared.model.RecordedTest;
import com.seitenbau.testing.shared.model.RecordedTestCase;
import com.seitenbau.testing.testgenerator.datadriven.GeneratorDataDriven;
import com.seitenbau.testing.testgenerator.partgenerator.impl.PartGeneratorReturnValueAssertXMLEquals;
import com.seitenbau.testing.testgenerator.partgenerator.impl.PartGeneratorTargetCreateNewInstance;



public class RunTestGenerator {

	public static void main(String[] args)
	{
		RecorderConfiguration rcfg = ConfigurationBuilder.build();

		List<RecordedMethodConfiguration> rmcfg = RepositoryService.getRecordedMethodConfigurations( rcfg);

		TestConfiguration testConfig = new TestConfiguration();
		testConfig.setTestData( rmcfg );


//		TestConfiguration tConfig = readTestsFromDatabase();
//
//		AtrHelper.writeFile( "testC.xml",  new XStream().toXML( tConfig ) );
//		tConfig.setTestGenerator( DataDrivenTestGenerator.class.getCanonicalName());

		GeneratorDataDriven generator = new GeneratorDataDriven();

		generator.addPartGenerator( new PartGeneratorTargetCreateNewInstance () );
		generator.addPartGenerator( new PartGeneratorReturnValueAssertXMLEquals() );

		TestGenerator.createTestArtifacts(generator, testConfig, "./src/test/java");
	}

//	private static TestConfiguration readTestsFromDatabase() {
//
//
//		List<RecordedMethodConfiguration> configs =
//			RepositoryService.getRecordedMethodConfigurations(
//					ConfigurationBuilder.build()
//				);
//
//		if(configs.isEmpty()) {
//			throw new IllegalArgumentException("No Tests recorded.");
//		}
//		RecordedMethodConfiguration rmConfig = configs.get(0);
//
//		TestConfiguration tConfig = new TestConfiguration( );
//
//		List<RecordedTest> tests=new LinkedList<RecordedTest>();
//		for(RecordedTestCase cases:rmConfig.getRecordedTestCases()) {
//			tests.addAll( cases.getRecordedTests());
//		}
//
//		tConfig.initFrom( tests );
//
//		tConfig.setTestGeneratorConfiguration( buildGeneratorConfig() );
//
//		tConfig.setFilters( buildFilters() );
//		return tConfig;
//	}



//	private static List<FilterConfiguration> buildFilters() {
//		List<FilterConfiguration> list=new Vector<FilterConfiguration>();
//		FilterConfiguration filter;
//
//		filter=new FilterConfiguration();
//		filter.setFilter("");
//		filter.setTargetMatch(String.class.getCanonicalName());
//		list.add( filter );
//
//		return list;
//	}

//	private static TestGeneratorConfiguration buildGeneratorConfig() {
//		TestGeneratorConfiguration conf=new TestGeneratorConfiguration();
//
//		TestPartGeneratorConfiguration tpart=null;
//		tpart = new TestPartGeneratorConfiguration();
//		tpart.setClassName(DbUnitGenerator.class.getCanonicalName());
//		conf.addTestPartGenerator(tpart);
//
////		TestPartGeneratorConfiguration tpart=null;
////		tpart = new TestPartGeneratorConfiguration();
////		tpart.setClassName(DbUnitGenerator.class.getCanonicalName());
////		conf.addTestPartGenerator(tpart);
////
////		tpart = new TestPartGeneratorConfiguration();
////		tpart.setClassName(ValidateReturnValue.class.getCanonicalName());
////		conf.addTestPartGenerator(tpart);
////
////		tpart = new TestPartGeneratorConfiguration();
////		tpart.setClassName(SetupFromPreState.class.getCanonicalName());
////		conf.addTestPartGenerator(tpart);
////
////		tpart = new TestPartGeneratorConfiguration();
////		tpart.setClassName(PartGeneratorFixtureFromNew.class.getCanonicalName());
////		conf.addTestPartGenerator(tpart);
//
//		return conf;
//	}

	@SuppressWarnings("unused")
	private static List<RecordedTest> buildTestList(List<RecordedMethodConfiguration> configs) {
		List<RecordedTest> tests=new LinkedList<RecordedTest>();
		for (RecordedMethodConfiguration recordConfig : configs) {
			for (RecordedTestCase recordedTestCase : recordConfig.getRecordedTestCases()) {
				tests.addAll( recordedTestCase.getRecordedTests() );
			}
		}
		return tests;
	}

}
